precision highp float;

varying vec2 textureCoordinate;
varying vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

float ln_e(float x) {
    return (step(0.0, x) - 0.5) * 2.0 * log(abs(x) + 1.0) * 0.7;
}

vec3 ln_e(vec3 s) {
    return vec3(ln_e(s.x), ln_e(s.y), ln_e(s.z));
}

void main() {
    vec3 color = texture2D(inputImageTexture, textureCoordinate).rgb;
    vec3 blurColor = texture2D(inputImageTexture2, textureCoordinate).rgb;
    vec3 resultColor = color - ln_e(color - blurColor);
    gl_FragColor = vec4(resultColor, 1.0);
}

