precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform float warpSize;

vec2 data2uv(vec4 data) {
    return data.xy + data.zw / 255.;
}

vec4 interp(vec2 uv){
    vec2 fxy = fract(uv * warpSize);
    vec2 uv_bl = uv - fxy/warpSize;
    vec4 bl = texture2D(inputImageTexture2, uv_bl);
    vec4 tl = texture2D(inputImageTexture2, uv_bl+vec2(0.0,1.0/warpSize));
    vec4 br = texture2D(inputImageTexture2, uv_bl+vec2(1.0/warpSize,0.0));
    vec4 tr = texture2D(inputImageTexture2, uv_bl+vec2(1.0/warpSize));
    return bl*(1.0-fxy.x)*(1.0-fxy.y) + tl*(1.0-fxy.x)*fxy.y + br*fxy.x*(1.0-fxy.y) + tr*fxy.x*fxy.y;
}

void main(void) {
    vec4 data = interp(textureCoordinate - 0.5/warpSize);
    vec2 uv = (data2uv(data) - 0.5) * 2.0 + textureCoordinate;
    vec4 textureColor = texture2D(inputImageTexture, uv);
    gl_FragColor = textureColor;
}